package me.akito123321.valoStrats.rest.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import me.akito123321.valoStrats.rest.requests.AuthenticationRequest;
import me.akito123321.valoStrats.rest.requests.AuthenticationResponse;
import me.akito123321.valoStrats.rest.util.JDBCUserDetailsService;
import me.akito123321.valoStrats.rest.util.StratsUser;

@RestController
@RequestMapping("/api/auth")
public class AuthenticationController {

	@Autowired
	private JDBCUserDetailsService userDetailsService;

	@Autowired
	private AuthenticationManager authManager;

	@PostMapping(value = "/login", produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<AuthenticationResponse> login(@RequestBody AuthenticationRequest request) {
		Authentication auth = authManager.authenticate(new UsernamePasswordAuthenticationToken("", request.code()));
		SecurityContextHolder.getContext().setAuthentication(auth);

		StratsUser user = (StratsUser) auth.getPrincipal();
		String token = userDetailsService.createToken(user.getUsername());
		if (token == null)
			return ResponseEntity.internalServerError().build();

		return ResponseEntity.ok(new AuthenticationResponse(user.getUsername(), user.getDisplayName(), token));
	}

}
