package me.akito123321.valoStrats.rest.util;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.authentication.dao.AbstractUserDetailsAuthenticationProvider;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.userdetails.UserDetails;

public class TokenAuthenticationManager extends AbstractUserDetailsAuthenticationProvider {

	@Autowired
	private JDBCUserDetailsService userDetailsService;

	@Override
	protected void additionalAuthenticationChecks(UserDetails userDetails, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
	}

	@Override
	protected UserDetails retrieveUser(String username, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
		UserDetails details = userDetailsService.loadUserByToken((String) authentication.getCredentials());
		if (details == null)
			throw new BadCredentialsException("Invalid token");
		return details;
	}

}
