package me.akito123321.valoStrats.schemas;

import java.util.ArrayList;
import java.util.List;

import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import me.akito123321.valoStrats.rest.util.StratsUser;

@Entity(name = "wishlist_group")
public class Group {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	private String name;
	@ManyToOne
	private StratsUser owner;
	@ManyToMany
	private List<StratsUser> members;
	@ManyToMany
	private List<Strat> strats;

	public Group(String name, StratsUser owner) {
		this.name = name;
		this.owner = owner;
		this.members = new ArrayList<StratsUser>();
		this.strats = new ArrayList<Strat>();
	}

	public Group() {

	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public StratsUser getOwner() {
		return owner;
	}

	public List<StratsUser> getMembers() {
		return members;
	}

	public List<Strat> getStrats() {
		return strats;
	}

	public void setName(String name) {
		this.name = name;
	}

}
