package me.akito123321.valoStrats.schemas;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.Lob;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;

@Entity
public class Strat {
	@Id
	@GeneratedValue(strategy = GenerationType.UUID)
	private String id;
	private String title;
	private String description;
	@ManyToOne
	private Group group;
	
	@Lob
    @Column(name = "imagedata", length = 1000)
	@OneToMany
    private byte[][] stratStates;
	
	@Lob
    @Column(name = "imagedata", length = 1000)
	@OneToMany
    private byte[][] lineups;

	public Strat(String title, String description, Group group, byte[][] stratStates, byte[][] lineups) {
		this.title = title;
		this.description = description;
		this.group = group;
		this.stratStates = stratStates;
		this.lineups = lineups;
	}

	public Strat() {

	}

	public String getId() {
		return id;
	}

	public String getTitle() {
		return title;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public byte[][] getStratStates() {
		return stratStates;
	}

	public void setStratStates(byte[][] stratStates) {
		this.stratStates = stratStates;
	}

	public byte[][] getLineups() {
		return lineups;
	}

	public void setLineups(byte[][] lineups) {
		this.lineups = lineups;
	}

}
